;;;---------------------------------------------------------------------------;
;;; Get user input.
;;;---------------------------------------------------------------------------;

(defun c:gpline (/ esel tyfilen tyfilty tytemp tyxyz tyx tyy tyz tycom tyl)
   ;;(setvar "OSMODE" 512)

      (setq tyfilen (getfiled "Export (x,y,z,layer) File Name" "" "tyl" 7))
      (setq tyfilty (OPEN tyfilen "w"))
      (princ "\nPlease wait, while ")
      (princ " points are exported to ")
      (princ tyfilen)
      (princ "...")

 (setq en0 (entsel "Pick any polyline <near> ") ; Main entity name
        pt0 (cadr en0)                   ; Pick point
        en0 (car en0)                    ; Main entity name
         e0 (entget en0)                 ; Main entity
        pl0 (nam 70 e0)                  ; 8= poly open 9= poly closed
         n1 1                            ; counter one
        ss1 (ssadd)                      ; create empty selection set
  )
 
 ;;(setvar "OSMODE" 0)
  
   (setq vname (entnext en0))
    (setq vlist (entget vname))

(if (cdr (assoc 0 vlist)) "LWPOLYLINE")
   (progn 
    (while (not (= "SEQEND" (nam 0 (entget (setq en0 (entnext en0))))))
      (setq pt (nam 10 (entget en0)))
 
    (cond (pt
         (setq tyxyz (cdr (assoc 10 vlist)))
         (setq tyx (rtos (car tyxyz) 2 3))
         (setq tyy (rtos (cadr tyxyz) 2 3))
         ;;(setq tyz (rtos (caddr tyxyz) 2 3))
         (setq tyl (cdr (assoc 8 vlist)))
         (setq tycom "       ")
         (while (< (strlen tyy) 12) (setq tyy (strcat " " tyy)) )
         (while (< (strlen tyx) 12) (setq tyx (strcat " " tyx)) )
         ;;(while (< (strlen tyz) 8) (setq tyz (strcat " " tyz)) )
         ;;(setq tylne (strcat "        " tyx tycom tyy tycom tyz "    " tyl))
         (setq tylne (strcat "        " tyx tycom tyy tycom tyl))
         (write-line tylne tyfilty)
         (setq vname (entnext vname))
         (setq vlist (entget vname))      
                  )
       )
       (setq n1 (+ n1 1)
      )
 
      ); end while
    ); end progn
  (progn 
   (while (not (= "SEQEND" (nam 0 (entget (setq en0 (entnext en0))))))
      (setq pt (nam 10 (entget en0)))
 
    (cond (pt
         (setq tyxyz (cdr (assoc 10 vlist)))
         (setq tyx (rtos (car tyxyz) 2 3))
         (setq tyy (rtos (cadr tyxyz) 2 3))
         (setq tyz (rtos (caddr tyxyz) 2 3))
         (setq tyl (cdr (assoc 8 vlist)))
         (setq tycom "      ")
         (while (< (strlen tyy) 12) (setq tyy (strcat " " tyy)) )
         (while (< (strlen tyx) 12) (setq tyx (strcat " " tyx)) )
         (while (< (strlen tyz) 8) (setq tyz (strcat " " tyz)) )
         (setq tylne (strcat "        " tyx tycom tyy tycom tyz "    " tyl))
         (setq tylne (strcat "        " tyx tycom tyy tycom tyl))
         (write-line tylne tyfilty)
         (setq vname (entnext vname))
         (setq vlist (entget vname))      
                  )
        )
       (setq n1 (+ n1 1)
       )
 
      );end while 
    );end progn    

       (close tyfilty)
        (Princ "Finished.")(princ)
        ;;(command "AREA" "e" "l")
        (redraw)
   );end fun
   (defun NAM (c1 e1)
        (cdr(assoc c1 e1))
    )
;;------------------------------------------------------------------------------------------------------------------

(defun c:g3dpline (/ esel tyfilen tyfilty tytemp tyxyz tyx tyy tyz tycom tyl)
   ;;(setvar "OSMODE" 512)

      (setq tyfilen (getfiled "Export (x,y,z,layer) File Name" "" "tyl" 7))
      (setq tyfilty (OPEN tyfilen "w"))
      (princ "\nPlease wait, while ")
      (princ " points are exported to ")
      (princ tyfilen)
      (princ "...")

 (setq en0 (entsel "Pick any 3Dpolyline <near> ") ; Main entity name
        pt0 (cadr en0)                   ; Pick point
        en0 (car en0)                    ; Main entity name
         e0 (entget en0)                 ; Main entity
        pl0 (nam 70 e0)                  ; 8= poly open 9= poly closed
         n1 1                            ; counter one
        ss1 (ssadd)                      ; create empty selection set
  )
 
 ;;(setvar "OSMODE" 0)
  
   (setq vname (entnext en0))
    (setq vlist (entget vname))

(if (cdr (assoc 0 vlist)) "SEQEND")
  (progn 
   (while (not (= "SEQEND" (nam 0 (entget (setq en0 (entnext en0))))))
      (setq pt (nam 10 (entget en0)))
 
    (cond (pt
         (setq tyxyz (cdr (assoc 10 vlist)))
         (setq tyx (rtos (car tyxyz) 2 3))
         (setq tyy (rtos (cadr tyxyz) 2 3))
         (setq tyz (rtos (caddr tyxyz) 2 3))
         (setq tyl (cdr (assoc 8 vlist)))
         (setq tycom "      ")
         (while (< (strlen tyy) 12) (setq tyy (strcat " " tyy)) )
         (while (< (strlen tyx) 12) (setq tyx (strcat " " tyx)) )
         (while (< (strlen tyz) 8) (setq tyz (strcat " " tyz)) )
         (setq tylne (strcat "        " tyx tycom tyy tycom tyz "    " tyl))
         ;;(setq tylne (strcat "        " tyx tycom tyy tycom tyl))
         (write-line tylne tyfilty)
         (setq vname (entnext vname))
         (setq vlist (entget vname))      
                  )
      )
     (setq n1 (+ n1 1)
     )
 
  );end while 
 );end progn    

 (progn 
   (while (not (= "SEQEND" (nam 0 (entget (setq en0 (entnext en0))))))
      (setq pt (nam 10 (entget en0)))
 
    (cond (pt
         (setq tyxyz (cdr (assoc 10 vlist)))
         (setq tyx (rtos (car tyxyz) 2 3))
         (setq tyy (rtos (cadr tyxyz) 2 3))
         ;;(setq tyz (rtos (caddr tyxyz) 2 3))
         (setq tyl (cdr (assoc 8 vlist)))
         (setq tycom "      ")
         (while (< (strlen tyy) 12) (setq tyy (strcat " " tyy)) )
         (while (< (strlen tyx) 12) (setq tyx (strcat " " tyx)) )
         ;;(while (< (strlen tyz) 8) (setq tyz (strcat " " tyz)) )
         ;;(setq tylne (strcat "        " tyx tycom tyy tycom tyz "    " tyl))
         (setq tylne (strcat "        " tyx tycom tyy tycom tyl))
         (write-line tylne tyfilty)
         (setq vname (entnext vname))
         (setq vlist (entget vname))      
                  )
      )
     (setq n1 (+ n1 1)
     )
 
  );end while 
 );end progn 
;end if
       (close tyfilty)
        (Princ "Finished.")(princ)
        ;;(command "AREA" "e" "l")
        (redraw)
   )
   (defun NAM (c1 e1)
        (cdr(assoc c1 e1))
    )